#ifndef _cache_h
#define _cache_h

#include <vector>
#include <string>

using namespace std;

class Site;

class Cache
{
 public:
#pragma pack(1)
  struct header
  {
    unsigned long magic;
    unsigned long points;
    unsigned long namelen;
    unsigned long flightlen;
    struct
    {
      double lat;
      double lon;
      double alt;
      double ant;
    } site;
  };
#pragma pack()
 
  Cache();
  ~Cache();

  bool LoadFromFile(char *fname);
  bool SaveToFile(char *fname);

  bool Value(unsigned long step);
  void Value(unsigned long step, bool val);

  void Count(unsigned long val)         { m_vValue.resize(val); }
  unsigned long Count()                 { return m_vValue.size(); }

  Site *POV()                           { return m_pSite; }
  void POV(Site &pov);

  string FlightName()                   { return m_sFlightName; }
  void FlightName(string v)             { m_sFlightName = v; }

  static void init();
  static void updatetoc();
  static int FindFiles(vector<string> &list);
  static bool Find(Site *pov, char *flight_name, string &cache_name);
  static string CacheDir;

 protected:
  bit_vector m_vValue;
  Site *m_pSite;
  string m_sFlightName;

  static unsigned long CacheNameCounter;
};

#endif
