#include "coord.h"
#include "geod.h"

Coord::Coord()
{
	Latitude = 0.0;
	Longitude = 0.0;
	Altitude = 0.0;
	Distance = 0.0;
#ifndef _NO_PLOTXY
	PlotX = -1;
	PlotY = -1;
#endif
}

Coord::Coord(double lat, double lon, double alt, double dist)
{
	Latitude = lat;
	Longitude = lon;
	Altitude = alt;
	Distance = dist;
#ifndef _NO_PLOTXY
	PlotX = -1;
	PlotY = -1;
#endif
}

Coord::Coord(const Coord &c)
{
	Latitude = c.Latitude;
	Longitude = c.Longitude;
	Altitude = c.Altitude;
	Distance = c.Distance;
#ifndef _NO_PLOTXY
	PlotX = c.PlotX;
	PlotY = c.PlotY;
#endif
}

void Coord::Print()
{
	cout<<"Latitude:  "<<geod::pos2str(Latitude, 0)<<endl;
	cout<<"Longitude: "<<geod::pos2str(Longitude, 1)<<endl;
	cout<<"Altitude:  "<<Altitude<<endl;
	cout<<"DIstance:  "<<Distance<<endl;
}

