#ifndef _coord_h
#define _coord_h

/*
Author: James A. Rogers (RogersJA@navair.navy.mil
Date:   2003-11-19 0918 PST (-8:00)
File:   coordinate.{cpp,h}

Class for the handling of a coordinate, storing latitude, longitude
and altitude.  The latitude and longitude are stored as F*8 (double),
as degrees, NOT radians.  Future version may include the capability
to handle positions in radians.


Date:   2004-12-09 0909 PST (-8:00)
Action: change class name to Coord and file names to coord.{cpp,h}
*/

#include <iostream>

using namespace std;

class Coord
{
public:
	Coord();
	Coord(double lat, double lon, double alt, double dist = 0.0);
	Coord(const Coord &c);

	void Print();

	double Latitude;
	double Longitude;
	double Altitude;
	double Distance;
#ifndef _NO_PLOTXY
	long PlotX;
	long PlotY;
#endif
};

#endif
