#include "geod.h"
#include <math.h>

string geod::pos2str(double pos, int latlon)
{
	char c, buf[24];
	int deg, min;
	double sec;

	if (latlon == 0)
		c = (pos < 0.0)?'S':'N';
	else c = (pos < 0.0)?'W':'E';

	pos = fabs(pos);

	deg = (int)pos;
	pos = (pos-deg)*60.0;
	min = (int)pos;
	pos = (pos-min)*60.0;
	sec = pos;

	_snprintf(buf, 23, "%03d%02d%f%c", deg, min, sec, c);
	return string(buf);
}

double geod::str2pos(string &str)
{
	return str2pos((char*)str.c_str());
}

double geod::str2pos(char *str)
{
	char c;
	int deg, min;
	float sec;
	double r;

	sscanf(str, "%3d%2d%f%c", &deg, &min, &sec, &c);

	r = (double)deg;
	r += (float)min/60.0;
	r += sec/3600.0;

	if (c == 'W' || c == 'S')
		r *= -1.0;

	return r;
}  

string geod::displaygeodetic(double pos, int latlon)
{
	char c, buf[24];
	int deg, min, seci, secf;
	double sec;

	if (latlon == 0)
		c = (pos < 0.0)?'S':'N';
	else c = (pos < 0.0)?'W':'E';

	pos = fabs(pos);

	deg = (int)pos;
	pos = (pos-deg)*60.0;
	min = (int)pos;
	pos = (pos-min)*60.0;
	sec = pos;

	seci = (int)sec;
	secf = (int)((sec-seci)*10.0);
	_snprintf(buf, 23, "%03d-%02d-%02d.%d%c", deg, min, seci, secf, c);

	return string(buf);
}

double geod::readgeodetic(char *pos)
{
	char c;
	int r, deg, min;
	float secf;
	double val;

	r = sscanf(pos, "%03d-%02d-%f%c", &deg, &min, &secf, &c);

	if (r == 4)
	{
		val = (float)deg+((float)min/60.0f)+(secf/3600.0f);
		switch (tolower(c))
		{
		case 'w':
		case 's':
			val = -val;
			break;

		case 'n':
		case 'e':
		default:
			break;
		}
	}
	else val = 0.0;

	return val;
}
