//---------------------------------------------------------------------------
#ifndef utmH
#define utmH

#include <string>
#include <stdio.h>
#include <math.h>

using namespace std;

struct DATUM
{
  char *name;
  short ellipsoid;
  short dx;
  short dy;
  short dz;
};

struct ELLIPSOID
{
  char *name;  // name of ellipsoid
  double a;    // semi-major axis, meters
  double invf; // 1/f
};
//---------------------------------------------------------------------------
class UTM
{
 public:
  static void DegToUTM(double lat, double lon, string &zone,
		       double *x, double *y, bool inRadians=false);
  static void UTMToDeg(short zone, short southernHemisphere,
		       double x, double y, double *lat, double *lon,
		       bool inRadians=false);
  static int DatumIndex;

 protected:
  static void toTM(double lat, double lon, double lat0,
		   double lon0, double k0,
		   double *x, double *y);
  static void fromTM(double x, double y, double lat0,
		     double lon0, double k0,
		     double *lat, double *lon);
  static void toUPS(double lat, double lon, double *x, double *y);
  static void fromUPS(short southernHemisphere, double x,
		      double y, double *lat, double *lon);

  static double M(double phi, double a, double es);
  static void calcPhi(double *phi, double e, double t);
  static void datumParams(short datum, double *a, double *es);
 private:
  static const double lat0;
  static const double k0;
  static const double Degree;
  static const struct ELLIPSOID gEllipsoid[23];
  static const struct DATUM gDatum[102];
};
#endif
