#ifndef _graphbase_win32_h
#define _graphbase_win32_h

//#include <cstdio>
#include <string>
//#include "common.h"

//#define _USE_MATH_DEFINES
//#include <math.h>

using namespace std;
#define INCLUDE_PNG_SUPPORT

class DTED;
class Path;
class Site;
class Plotter;
class XPlotter;
class PNGPlotter;
class BMPPlotter;

class GraphBase
{
public:
	enum { gtX = 0, gtPNG, gtBMP };

	GraphBase(int type);
	virtual ~GraphBase();

	virtual bool Allocate(int maxwidth = -1, int maxheight = -1) = 0;
	virtual bool Generate() = 0;
	virtual bool DrawPath(Path *path, unsigned short col[3], int size) = 0;
	virtual void DrawSite(Site *p, unsigned short col[3], float size, bool showlabel) = 0;
	virtual void DrawPoint(Site *p, unsigned short col[3], float size) = 0;
	virtual void DrawParallelPoint(Site *p1, Site *p2, unsigned short col[3], float size, int level) = 0;
	virtual void DrawParallelLine(Site *p1, Site *p2, unsigned short col[3], float size, int level) = 0;
	
	virtual bool Close();

	Plotter *Handle();

	bool IsOpen()							{ return m_bOpen; }

	bool GrayScale() const					{ return m_bGrayScale; }
	bool &GrayScale()						{ return m_bGrayScale; }

	double Gamma() const					{ return m_dGamma; }
	double &Gamma()							{ return m_dGamma; }

protected:
	bool DrawCell(DTED *cell, int xindex, int yindex);
	bool DrawCellOffset(DTED *cell, int xorg, int yorg);
	void ColorRamp(int range, int value, unsigned short *red, unsigned short *green, unsigned short *blue);
	void GrayRamp(int value, int minalt, int maxalt, unsigned short *r, unsigned short *g, unsigned short *b);

	union
	{
		XPlotter *x;
		PNGPlotter *png;
		BMPPlotter *bmp;
		Plotter *p;
	} m_pHandle;
	FILE *m_pOutputFile;
	bool m_bOpen;
	bool m_bGrayScale;
	double m_dGamma;
	int m_iMinAltitude;
	int m_iMaxAltitude;
	int m_iPlotterType;
};

#endif
