#ifndef _graphdted_win32_h
#define _graphdted_win32_h

#include <cstdio>
#include <string>
#include "common.h"

#define _USE_MATH_DEFINES
#include <math.h>

using namespace std;
#define INCLUDE_PNG_SUPPORT

#include "graphbase_win32.h"

class GraphDted : public GraphBase
{
public:
	GraphDted(int type, DTED *d);
	~GraphDted();

	bool Allocate(int maxwidth = -1, int maxheight = -1);
	bool Generate();
	bool DrawPath(Path *path, unsigned short col[3], int size);
	void DrawSite(Site *p, unsigned short col[3], float size, bool showlabel);
	void DrawPoint(Site *p, unsigned short col[3], float size);
	void DrawParallelPoint(Site *p1, Site *p2, unsigned short col[3], float size, int level);
	void DrawParallelLine(Site *p1, Site *p2, unsigned short col[3], float size, int level);

protected:
	DTED *m_pCell;
};

#endif
