#ifndef _graphdtedgrid_win32_h
#define _graphdtedgrid_win32_h

#include <cstdio>
#include <string>
#include "common.h"

#define _USE_MATH_DEFINES
#include <math.h>

using namespace std;
#define INCLUDE_PNG_SUPPORT

#include "graphbase_win32.h"
class DTEDGrid;

class GraphDtedGrid : public GraphBase
{
public:
	GraphDtedGrid(int type, DTEDGrid *g);
	~GraphDtedGrid();

	bool Allocate(int maxwidth = -1, int maxheight = -1);
	bool Generate();
	bool DrawPath(Path *path, unsigned short col[3], int size);
	void DrawSite(Site *p, unsigned short col[3], float size, bool showlabel);
	void DrawPoint(Site *p, unsigned short col[3], float size);
	void DrawParallelPoint(Site *p1, Site *p2, unsigned short col[3], float size, int level);
	void DrawParallelLine(Site *p1, Site *p2, unsigned short col[3], float size, int level);

	bool Close();
	
protected:
	DTEDGrid *m_pGrid;
};

#endif
