// optlosDlg.cpp : implementation file
//

#include "stdafx.h"
#include "optlos.h"
#include "optlosDlg.h"
#include ".\optlosdlg.h"

#include "collection.h"
#include "analysisthread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// COptLosDlg dialog



COptLosDlg::COptLosDlg(CWnd* pParent /*=NULL*/)
: CDialog(COptLosDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	//m_sDtedPath = "\\\\atropos\\dted\\california\\dted\\";
	m_sDtedPath = "\\\\archive\\dted-data\\california\\dted\\";
	m_pFlightCol = NULL;
	m_pEmitterCol = NULL;
	//m_fStepSize = 0.03f;
	m_fStepSize = 0.1f;
	m_mControlFlags["RenderDted"] = true;
	m_mControlFlags["MinCoverage"] = true;
	m_mControlFlags["Analyze"] = false;
	m_mControlFlags["DisplayRealtime"] = false;
	m_bFlags[0] = false;
	m_bFlags[1] = false;
}

COptLosDlg::~COptLosDlg()
{
	if (m_pFlightCol)
	{
		delete m_pFlightCol;
		m_pFlightCol = NULL;
	}

	if (m_pEmitterCol)
	{
		delete m_pEmitterCol;
		m_pEmitterCol = NULL;
	}
}

void COptLosDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LBL_FLIGHT_SIZE, lblFlightSize);
	DDX_Control(pDX, IDC_LBL_EMITTER_SIZE, lblEmitterSize);
	DDX_Control(pDX, IDC_BTN_ANALYZE, btnAnalyze);
	DDX_Control(pDX, IDC_LST_STATUS, lstStatus);
	DDX_Control(pDX, IDC_PRG_ANALYSIS, prgAnalysis);
	DDX_Control(pDX, IDC_LBL_PROGRESS, lblProgress);
	DDX_Control(pDX, IDC_CHECK_RENDER_DTED, chkRenderDted);
	DDX_Control(pDX, IDC_CHECK_MIN_COVERAGE, chkMinCoverage);
	DDX_Control(pDX, IDC_CHECK_ANALYZE_PATH, chkAnalyzePath);
	DDX_Control(pDX, IDC_CHECK_DISPLAY_REALTIME, chkDisplayRealtime);
	DDX_Control(pDX, IDC_PRG_ANALYSIS2, prgAnalysis2);
	DDX_Control(pDX, IDC_LBL_PROGRESS2, lblProgress2);
}

BEGIN_MESSAGE_MAP(COptLosDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_LOAD_EXIT, OnLoadExit)
	ON_COMMAND(ID_LOAD_FLIGHT, OnLoadFlight)
	ON_COMMAND(ID_LOAD_EMITTERS, OnLoadEmitters)
	ON_BN_CLICKED(IDC_BTN_ANALYZE, OnBnClickedBtnAnalyze)
	ON_BN_CLICKED(IDC_CHECK_RENDER_DTED, OnBnClickedCheckRenderDted)
	ON_BN_CLICKED(IDC_CHECK_MIN_COVERAGE, OnBnClickedCheckMinCoverage)
	ON_BN_CLICKED(IDC_CHECK_ANALYZE_PATH, OnBnClickedCheckAnalyzePath)
	ON_BN_CLICKED(IDC_CHECK_DISPLAY_REALTIME, OnBnClickedCheckDisplayRealtime)
END_MESSAGE_MAP()


// COptLosDlg message handlers

BOOL COptLosDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	/* set checkboxes to match flags */
	chkRenderDted.SetCheck((m_mControlFlags["RenderDted"] == true)?BST_CHECKED:BST_UNCHECKED);
	chkMinCoverage.SetCheck((m_mControlFlags["MinCoverage"] == true)?BST_CHECKED:BST_UNCHECKED);
	chkAnalyzePath.SetCheck((m_mControlFlags["Analyze"] == true)?BST_CHECKED:BST_UNCHECKED);
	chkDisplayRealtime.SetCheck((m_mControlFlags["DisplayRealtime"] == true)?BST_CHECKED:BST_UNCHECKED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COptLosDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COptLosDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COptLosDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL COptLosDlg::PreTranslateMessage(MSG * pMsg)
{
	/* ignore RETURN and ESCAPE (don't close dialog like default) */
	if (pMsg->message == WM_KEYDOWN)
	{
		switch ((int)pMsg->wParam)
		{
		case VK_RETURN:
		case VK_ESCAPE:
			return true;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void COptLosDlg::OnLoadExit()
{
	/* end the dialog */
	EndDialog(IDOK);
}

void COptLosDlg::OnLoadFlight()
{
	CString str;
	CFileDialog fileDlg(TRUE, ".sp", ".\\*.sp",
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
		"Flight Profiles|*.sp", NULL);

	/* show the file dialog */
	if (fileDlg.DoModal() == IDOK)
	{
		CString pathName = fileDlg.GetPathName();
		CString fileName = fileDlg.GetFileTitle();

		m_pFlightCol = new Collection((char*)pathName.GetString());
		str.Format("%d", m_pFlightCol->SiteCount());
		lblFlightSize.SetWindowText(str);
		m_bFlags[0] = true;

		str.Format("Loaded %d points for flight path", m_pFlightCol->SiteCount());
		privThreadStatusCallback(str);

		btnAnalyze.EnableWindow(m_bFlags[0] && m_bFlags[1]);
	}
}

void COptLosDlg::OnLoadEmitters()
{
	CString str;
	CFileDialog fileDlg(TRUE, ".sp", ".\\*.sp",
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, 
		"Emitter Profiles|*.sp", NULL);

	/* show the file dialog */
	if (fileDlg.DoModal() == IDOK)
	{
		CString pathName = fileDlg.GetPathName();
		CString fileName = fileDlg.GetFileTitle();

		m_pEmitterCol = new Collection((char*)pathName.GetString());
		str.Format("%d", m_pEmitterCol->SiteCount());
		lblEmitterSize.SetWindowText(str);
		m_bFlags[1] = true;

		str.Format("Loaded %d points for emitters", m_pEmitterCol->SiteCount());
		privThreadStatusCallback(str);

		btnAnalyze.EnableWindow(m_bFlags[0] && m_bFlags[1]);
	}
}

void COptLosDlg::OnBnClickedBtnAnalyze()
{
	CString str;

	/* get current button label */
	btnAnalyze.GetWindowText(str);

	/* check which behavior to use */
	if (str == "&Analyze")
	{
		/* create a new thread for analysis */
		m_pThread = new AnalysisThread(this, m_pFlightCol, m_pEmitterCol, m_sDtedPath,
									   m_fStepSize, m_mControlFlags);

		if (m_mControlFlags["DisplayRealtime"] == true)
		{
			/* create the display dialog */
			m_Display.Create(IDD_DIALOG_DISPLAY, NULL);
			m_Display.ShowWindow(SW_NORMAL);

			/* set the plotter for the display dialog */
			m_Display.SetPlotter(m_pThread->GetPlotter());
		}

		/* set the new button label */
		btnAnalyze.SetWindowText("&Stop");

		/* activate a timer to monitor the thread completion status */
		SetTimer(1, 1000, NULL);

		/* tell the thread to begin operations */
		m_pThread->Resume();
	}
	else
	{
		if (m_mControlFlags["DisplayRealtime"] == true)
		{
			/* close the display window */
			m_Display.DestroyWindow();
		}

		/* terminate the thread */
		m_pThread->Terminate();

		/* set the new button label */
		btnAnalyze.SetWindowText("&Analyze");

		/* disable button until thread terminates */
		btnAnalyze.EnableWindow(false);
	}
}

void COptLosDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1)
	{
		/* check if thread is allocated */
		if (!m_pThread)
			return;

		/* check thread status */
		if (!m_pThread->Terminated())
			return;

		/* thread has terminated */

		/* disable timer */
		KillTimer(1);

		/* deallocate thread */
		delete m_pThread;
		m_pThread = NULL;

		/* enable button */
		btnAnalyze.EnableWindow(true);

		/* change button text */
		btnAnalyze.SetWindowText("&Analyze");

		/* show message box */
		MessageBox("Complete");
	}
}

void COptLosDlg::privThreadStatusCallback(CString &str)
{
	int count;

	count = lstStatus.GetCount();
	lstStatus.AddString(str);
	lstStatus.SetCurSel(count);
}

void COptLosDlg::OnBnClickedCheckRenderDted()
{
	/* set/clear flag to render DTED */
	m_mControlFlags["RenderDted"] = (chkRenderDted.GetCheck() == BST_CHECKED);
}

void COptLosDlg::OnBnClickedCheckMinCoverage()
{
	/* set/clear flag to show minimum coverage (stop after first successful view) */
	m_mControlFlags["MinCoverage"] = (chkMinCoverage.GetCheck() == BST_CHECKED);
}

void COptLosDlg::OnBnClickedCheckAnalyzePath()
{
	/* set/clear flag to analyze the flight path */
	m_mControlFlags["Analyze"] = (chkAnalyzePath.GetCheck() == BST_CHECKED);
}

void COptLosDlg::OnBnClickedCheckDisplayRealtime()
{
	/* set/clear flag to display the flight in realtime */
	m_mControlFlags["DisplayRealtime"] = (chkDisplayRealtime.GetCheck() == BST_CHECKED);
}
