// optlosDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "optlosdisplaydlg.h"

#include <map>
#include <string>

class AnalysisThread;
class Collection;

// COptLosDlg dialog
class COptLosDlg : public CDialog
{
// Construction
public:
	COptLosDlg(CWnd* pParent = NULL);	// standard constructor
	~COptLosDlg();

// Dialog Data
	enum { IDD = IDD_OPTLOS_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	void privThreadStatusCallback(CString &str);

	HICON m_hIcon;
	COptLosDisplayDlg m_Display;

	Collection *m_pFlightCol;
	Collection *m_pEmitterCol;
	CString m_sDtedPath;
	float m_fStepSize;
	AnalysisThread *m_pThread;
	std::map<std::string,bool> m_mControlFlags;
	bool m_bFlags[2];

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL PreTranslateMessage(MSG * pMsg);
	afx_msg void OnLoadExit();
	afx_msg void OnLoadFlight();
	afx_msg void OnLoadEmitters();
	CStatic lblFlightSize;
	CStatic lblEmitterSize;
	CButton btnAnalyze;
	afx_msg void OnBnClickedBtnAnalyze();
	CListBox lstStatus;
	CProgressCtrl prgAnalysis;
	CStatic lblProgress;
	CButton chkRenderDted;
	CButton chkMinCoverage;
	CButton chkAnalyzePath;
	afx_msg void OnBnClickedCheckRenderDted();
	afx_msg void OnBnClickedCheckMinCoverage();
	afx_msg void OnBnClickedCheckAnalyzePath();
	CButton chkDisplayRealtime;
	afx_msg void OnBnClickedCheckDisplayRealtime();
	CProgressCtrl prgAnalysis2;
	CStatic lblProgress2;
};
