#ifndef _plotter_h
#define _plotter_h

#include "stdafx.h"
#include <map>
#include <string>

#define DC_BRUSH            18
#define DC_PEN              19

class Plotter
{
public:
	Plotter(FILE *stream);
	~Plotter();

	int openpl();
	void closepl();
	void pencolor(int r, int g, int b);
	void fillcolor(int r, int g, int b);
	void point(int x, int y);
	void fpoint(float fx, float fy);
	void marker(int x, int y, int type, int sz);
	void space(int xmin, int ymin, int xmax, int ymax);
	void fspace(float fxmin, float fymin, float fxmax, float fymax);
	void bgcolor(int r, int g, int b);
	void erase();
	void line(int x1, int y1, int x2, int y2);
	void fline(float fx1, float fy1, float fx2, float fy2);
	void linewidth(int sz);
	void rectangle(int x1, int y1, int x2, int y2);
	void ellipse(int x1, int y1, int x2, int y2);
	void alabel(char x_align, char y_align, char *str);

	void DoMyBidding();
	void TestPattern_1200_2400();
	
	CDC *GetDC()							{ return &m_hImageDC; }
	int Width()								{ return m_iWidth; }
	int Height()							{ return m_iHeight; }

	static void parampl(char *key, char *buf);

protected:
	bool WriteStream();

	void *m_pHandle;
	FILE *m_pFile;
	CDC m_hImageDC;
	CBitmap m_hBitmap;
	COLORREF m_rPenColor;
	COLORREF m_rBackgroundColor;
	COLORREF m_rFillColor;
	int m_iLineWidth;

	static int m_iWidth;
	static int m_iHeight;
	static std::map<std::string,std::string> m_mParams;
};

class XPlotter : public Plotter
{
public:
	XPlotter(FILE *stream) : Plotter(stream) { }
};

class PNGPlotter : public Plotter
{
public:
	PNGPlotter(FILE *stream) : Plotter(stream) { }
};

class BMPPlotter : public Plotter
{
public:
	BMPPlotter(FILE *stream) : Plotter(stream) { }
};


#endif