// viewport1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "viewport1.h"
#include "viewport1Dlg.h"
#include ".\viewport1dlg.h"
#include "plotter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CViewport1Dlg dialog



CViewport1Dlg::CViewport1Dlg(CWnd* pParent /*=NULL*/)
: CDialog(CViewport1Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iPaintBehavior = 0;
}

void CViewport1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, cmbType);
}

BEGIN_MESSAGE_MAP(CViewport1Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
END_MESSAGE_MAP()


// CViewport1Dlg message handlers

BOOL CViewport1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	MoveWindow(0, 0, 688, 474);

	int i;
	CString str;
	for (i = 0; i < 15; i++)
	{
		str.Format("%d", i);
		cmbType.AddString(str);
	}
	cmbType.AddString("255");
	cmbType.AddString("256");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CViewport1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
		CRect rect;

		GetClientRect(&rect);

		if (m_iPaintBehavior == 255)
		{
			Plotter p(stdin);
			p.DoMyBidding(dc.m_hDC);
		}
		if (m_iPaintBehavior == 256)
		{
			Plotter::parampl("BITMAPSIZE", "1200x2400");
			Plotter p(stdin);
			p.TestPattern_1200_2400(dc.m_hDC);
		}
		else if (m_iPaintBehavior == 0)
		{
			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);
		}
		else if (m_iPaintBehavior == 1)
		{
			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 0));
			dc.MoveTo(rect.Width()/2, 0);
			dc.LineTo(rect.Width()/2, rect.Height());
			dc.MoveTo(0, rect.Height()/2);
			dc.LineTo(rect.Width(), rect.Height()/2);
		}
		else if (m_iPaintBehavior == 2)
		{
			/* THIS IS IMPORTANT: x and y signs are reversed from the GDI example */
			dc.SetWindowOrg(-(rect.Width()/2), -(rect.Height()/2));

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 0));
			dc.MoveTo(rect.Width()/2, 0);
			dc.LineTo(rect.Width()/2, rect.Height());
			dc.MoveTo(0, rect.Height()/2);
			dc.LineTo(rect.Width(), rect.Height()/2);
		}
		else if (m_iPaintBehavior == 3)
		{
			/* THIS IS IMPORTANT: x and y signs are reversed from the GDI example */
			dc.SetWindowOrg(-300, -200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 0));
			dc.MoveTo(0, 300);
			dc.LineTo(0, -300);
			dc.MoveTo(-400, 0);
			dc.LineTo(400, 0);
		}
		else if (m_iPaintBehavior == 4)
		{
			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(0, 0);
			dc.LineTo(120, 0);
		}
		else if (m_iPaintBehavior == 5)
		{
			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(0, 0);
			dc.LineTo(120, 0);

			dc.SetDCPenColor(RGB(0, 0, 0));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);
		}
		else if (m_iPaintBehavior == 6)
		{
			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);

			dc.SetDCPenColor(RGB(0, 255, 0));
			dc.MoveTo(0, 0);
			dc.LineTo(150, 150);
		}
		else if (m_iPaintBehavior == 7)
		{
			dc.SetMapMode(MM_LOENGLISH);

			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);

			dc.SetDCPenColor(RGB(0, 255, 0));
			dc.MoveTo(0, 0);
			dc.LineTo(150, 150);
		}
		else if (m_iPaintBehavior == 8)
		{
			dc.SetMapMode(MM_HIENGLISH);

			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);

			dc.SetDCPenColor(RGB(0, 255, 0));
			dc.MoveTo(0, 0);
			dc.LineTo(150, 150);
		}
		else if (m_iPaintBehavior == 9)
		{
			dc.SetMapMode(MM_LOMETRIC);

			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);

			dc.SetDCPenColor(RGB(0, 255, 0));
			dc.MoveTo(0, 0);
			dc.LineTo(150, 150);
		}
		else if (m_iPaintBehavior == 10)
		{
			dc.SetMapMode(MM_HIMETRIC);

			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(300, 200);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* draw ellipse */
			dc.Ellipse(-100, -100, 100, 100);

			dc.SetDCPenColor(RGB(0, 0, 255));
			dc.MoveTo(-300, 0);
			dc.LineTo(300, 0);
			dc.MoveTo(0, -200);
			dc.LineTo(0, 200);

			dc.SetDCPenColor(RGB(0, 255, 0));
			dc.MoveTo(0, 0);
			dc.LineTo(150, 150);
		}
		else if (m_iPaintBehavior == 11)
		{
			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* set brush color */
			dc.SelectObject(GetStockObject(DC_BRUSH));
			dc.SetDCBrushColor(RGB(0, 0, 0x80));

			/* draw rectangle */
			dc.Rectangle(-100, -100, 100, 100);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw 45deg line */
			dc.MoveTo(0, 0);
			dc.LineTo(200, 200);
		}
		else if (m_iPaintBehavior == 12)
		{
			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(340, 220);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* set brush color */
			dc.SelectObject(GetStockObject(DC_BRUSH));
			dc.SetDCBrushColor(RGB(0, 0, 0x80));

			/* draw rectangle */
			dc.Rectangle(-100, -100, 100, 100);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw 45deg line */
			dc.MoveTo(0, 0);
			dc.LineTo(200, 200);
		}
		else if (m_iPaintBehavior == 13)
		{
			dc.SetMapMode(MM_ISOTROPIC);

			/* THIS IS IMPORTANT: x and y signs are NOT reversed from the GDI example */
			dc.SetViewportOrg(340, 220);
			//dc.SetViewportOrg(0, rect.Height());

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(255, 0, 0));

			/* set brush color */
			dc.SelectObject(GetStockObject(DC_BRUSH));
			dc.SetDCBrushColor(RGB(0, 0, 0x80));

			/* draw rectangle */
			dc.Rectangle(-100, -100, 100, 100);

			/* set pen color */
			dc.SelectObject(GetStockObject(DC_PEN));
			dc.SetDCPenColor(RGB(0, 0, 255));

			/* draw 45deg line */
			dc.MoveTo(0, 0);
			dc.LineTo(200, 200);
		}



		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CViewport1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CViewport1Dlg::OnCbnSelchangeCombo1()
{
	int index, v, r;
	CString str;

	// TODO: Add your control notification handler code here
	index = cmbType.GetCurSel();

	if (index == -1)
		return;

	cmbType.GetLBText(index, str);
	r = sscanf(str.GetString(), "%d", &v);

	if (r == 1)
	{
		m_iPaintBehavior = v;
		Invalidate();
	}
}
